--
-- Demonstration of Undulate with meshes and Craft
--

function setup()
    --setup some basic values
    quickTableInsert = table.insert -- cache this function for speed
    --setup the parameters
    parametersSetup()
    --setup the squares
    meshSetup()
    craftSetup()
    makeNewSquares()
    makeNewShader()
    craftUI = ui.label
    {
        x=WIDTH/2 - 200,
        y=HEIGHT - 180,
        w=400,
        h=200,
        opaque=false,
        text = "Craft version",
        fontSize = 32,
        fill = color(236, 209, 67)
    }
    local bg = readImage(asset.builtin.UI.Blue_Button11)
--    craftUI = imageButton(WIDTH/2-200,HEIGHT/2-100,400,200,bg, true)
end

function imageButton(x,y,w,h,i,f)
    local button = ui.label
    {
        x=x,
        y=y,
        w=w,
        h=h,
        opaque=false,
        text = "UI",
        fontSize = 100,
       -- normalBg = i,
      --  highlightedBg = asset.builtin.UI.Blue_Button10,
        normalFill = color(255, 255, 255, 255),
        align = {h = ui.CENTER, v = ui.CENTER},
        inset = 10
    }
    
    return button
end

function makeNewSquares()
    if not craftVersionToggle then
        makeMeshSquares()
        cameraFocuser = squaresPerSide / 2 * (math.min(WIDTH, HEIGHT) / squaresPerSide)
    else
        makeCraftSquares()
    end
end

function parametersSetup()
    parameter.boolean("craftVersionToggle", false, makeNewSquares)
    parameter.boolean("refreshBackground", true)
    parameter.integer("verticalDistanceIncrement", 1, 100, 20, makeNewSquares)
    parameter.integer("squaresPerSide", 1, 100, 20, makeNewSquares)
    parameter.boolean("showDebugColors", false, function(value)
        entity.material.showDebugColors = value;
    end)
end

function update(dt)
    scene:update(dt)
end

function draw()
    if refreshBackground then
        background(0)
    end
    update(DeltaTime)
    if craftVersionToggle then
        resetMatrix()
        if entity.material and entity.material.time then
            entity.material.time = ElapsedTime * 3
        end
        scene:draw()
        craftUI:update()
        craftUI:draw()
    else
        pushStyle()
        pushMatrix()
        resetMatrix()
        fill(236, 209, 67)
        fontSize(32) 
        text("mesh version", WIDTH/2, HEIGHT - 80)
        popMatrix()
        perspective()         
        if cameraFocuser and meshyMesh then
            camera(cameraFocuser, -200, 1000, cameraFocuser, cameraFocuser, 0, 0, 1, 0)
            meshyMesh.shader.time = ElapsedTime * 3
            meshyMesh:draw()
        end
        popStyle()
    end
end

function touched(touch)
    touches.touched(touch)
end
